diff --git a/src/plugins/styles/mac/qmacstyle_mac.mm b/src/plugins/styles/mac/qmacstyle_mac.mm
index 6b74205fda..51dbec4513 100644
--- a/src/plugins/styles/mac/qmacstyle_mac.mm
+++ b/src/plugins/styles/mac/qmacstyle_mac.mm
@@ -3911,6 +3924,11 @@ void QMacStyle::drawControl(ControlElement ce, const QStyleOption *opt, QPainter
                     frameRect = frameRect.adjusted(-innerAdjust, 0, outerAdjust, 0);
                 else
                     frameRect = frameRect.adjusted(-outerAdjust, 0, innerAdjust, 0);
+
+                if (isSelected && isBigSurOrAbove) {
+                    // 1 pixel of 'roundness' is still visible on the left.
+                    frameRect = frameRect.adjusted(-1, 0, 0, 0);
+                }
                 break;
             case QStyleOptionTab::OnlyOneTab:
                 frameRect = frameRect.adjusted(-outerAdjust, 0, outerAdjust, 0);
-- 
2.33.0

#From f1f650dc3aaf21df064703a9dcf405a222229226 Mon Sep 17 00:00:00 2001
#From: Edward Welbourne <edward.welbourne@qt.io>
#Date: Mon, 26 Oct 2020 14:39:54 +0100
#Subject: [PATCH 007/262] Deprecate ordering on QItemSelectionRange
#
#Ready for removal at Qt 6, as advocated in a ### comment.
#It was never done consistently with operator==(), apparently, and
#should not be needed in any case.
#
#[ChangeLog][QtCore][QItemSelectionRange] Ordering of
#QItemSelectionRange is now deprecated. It was not consistent with
#equality and should not be needed.
#
#Task-number: QTBUG-85700
#Change-Id: Ie99294bd7fc18f2a497598ae08840886b0a6d62d
#Reviewed-by: Lars Knoll <lars.knoll@qt.io>
#(cherry picked from commit 29c113d912fdf96f99503c9635bf89c4cabcc6fb)
#Reviewed-by: Qt Cherry-pick Bot <cherrypick_bot@qt-project.org>
#---
# src/corelib/itemmodels/qitemselectionmodel.cpp              | 4 +++-
# src/corelib/itemmodels/qitemselectionmodel.h                | 6 ++++--
# .../qitemselectionmodel/tst_qitemselectionmodel.cpp         | 4 ++++
# 3 files changed, 11 insertions(+), 3 deletions(-)
#
#diff --git a/src/corelib/itemmodels/qitemselectionmodel.cpp b/src/corelib/itemmodels/qitemselectionmodel.cpp
#index 27442fb2fa..6eadc77f78 100644
#--- a/src/corelib/itemmodels/qitemselectionmodel.cpp
#+++ b/src/corelib/itemmodels/qitemselectionmodel.cpp
#@@ -1,6 +1,6 @@
# /****************************************************************************
# **
#-** Copyright (C) 2016 The Qt Company Ltd.
#+** Copyright (C) 2020 The Qt Company Ltd.
# ** Contact: https://www.qt.io/licensing/
# **
# ** This file is part of the QtCore module of the Qt Toolkit.
#@@ -274,6 +274,7 @@ QItemSelectionRange QItemSelectionRange::intersected(const QItemSelectionRange &
# 
# */
# 
#+#if QT_DEPRECATED_SINCE(5, 15)
# /*!
#     Returns \c true if the selection range is less than the \a other
#     range given; otherwise returns \c false.
#@@ -312,6 +313,7 @@ bool QItemSelectionRange::operator<(const QItemSelectionRange &other) const
#     std::less<const QAbstractItemModel *> less;
#     return less(tl.model(), other.tl.model());
# }
#+#endif
# 
# /*!
#     \fn bool QItemSelectionRange::isValid() const
#diff --git a/src/corelib/itemmodels/qitemselectionmodel.h b/src/corelib/itemmodels/qitemselectionmodel.h
#index 5820695592..d79fb89156 100644
#--- a/src/corelib/itemmodels/qitemselectionmodel.h
#+++ b/src/corelib/itemmodels/qitemselectionmodel.h
#@@ -1,6 +1,6 @@
# /****************************************************************************
# **
#-** Copyright (C) 2016 The Qt Company Ltd.
#+** Copyright (C) 2020 The Qt Company Ltd.
# ** Contact: https://www.qt.io/licensing/
# **
# ** This file is part of the QtCore module of the Qt Toolkit.
#@@ -114,7 +114,9 @@ public:
#         { return (tl == other.tl && br == other.br); }
#     inline bool operator!=(const QItemSelectionRange &other) const
#         { return !operator==(other); }
#-    bool operator<(const QItemSelectionRange &other) const;
#+#if QT_DEPRECATED_SINCE(5, 15)
#+    QT_DEPRECATED bool operator<(const QItemSelectionRange &other) const;
#+#endif
# 
#     inline bool isValid() const
#     {
#diff --git a/tests/auto/corelib/itemmodels/qitemselectionmodel/tst_qitemselectionmodel.cpp b/tests/auto/corelib/itemmodels/qitemselectionmodel/tst_qitemselectionmodel.cpp
#index 6b59a6f1af..12cc584773 100644
#--- a/tests/auto/corelib/itemmodels/qitemselectionmodel/tst_qitemselectionmodel.cpp
#+++ b/tests/auto/corelib/itemmodels/qitemselectionmodel/tst_qitemselectionmodel.cpp
#@@ -82,8 +82,10 @@ private slots:
#     void layoutChangedWithAllSelected2();
#     void layoutChangedTreeSelection();
#     void deselectRemovedMiddleRange();
#+#if QT_DEPRECATED_SINCE(5, 15)
#     void rangeOperatorLessThan_data();
#     void rangeOperatorLessThan();
#+#endif
#     void setModel();
# 
#     void testDifferentModels();
#@@ -2441,6 +2443,7 @@ static QStandardItemModel* getModel(QObject *parent)
#     return model;
# }
# 
#+#if QT_DEPRECATED_SINCE(5, 15)
# enum Result {
#     LessThan,
#     NotLessThan,
#@@ -2575,6 +2578,7 @@ void tst_QItemSelectionModel::rangeOperatorLessThan()
#     if (!(r2 < r4))
#         QVERIFY(r4 < r2);
# }
#+#endif
# 
# void tst_QItemSelectionModel::setModel()
# {
#-- 
#2.33.0
#
#From b8518414c3ca1fe9eb32a2fe740a730b3104d36f Mon Sep 17 00:00:00 2001
#From: Edward Welbourne <edward.welbourne@qt.io>
#Date: Tue, 20 Oct 2020 11:18:14 +0200
#Subject: [PATCH 008/262] Deprecate QLocale::Language entries that no locale
# data relates to
#
#These are languages for which CLDR does not even recognize the claimed
#language code (three-letter codes except for bh = Bihari, which might
#be an old name for bho = Bhojpuri, which CLDR does give, but provides
#no locale data using it).
#
#[ChangeLog][QtCore][QLocale::Language] Many obsolete language names
#are now deprecated in preparation for removal at Qt 6.0. No data has
#been available for any locale using these languages since CLDR v29 (at
#least; Qt now uses v37).
#
#Task-number: QTBUG-84669
#Change-Id: I2bf2d49211ade7cc511277f35fb1a247e7048b31
#Reviewed-by: Lars Knoll <lars.knoll@qt.io>
#(cherry picked from commit 2575a8ced39b607ed320ed230c83119eaad4b33b)
#Reviewed-by: Qt Cherry-pick Bot <cherrypick_bot@qt-project.org>
#---
# src/corelib/text/qlocale.h                    | 132 ++++++++++++------
# src/corelib/text/qlocale.qdoc                 |  86 ++++++------
# .../auto/corelib/text/qlocale/tst_qlocale.cpp |  22 +--
# 3 files changed, 144 insertions(+), 96 deletions(-)
#
#diff --git a/src/corelib/text/qlocale.h b/src/corelib/text/qlocale.h
#index f975a28761..64dd32cabc 100644
#--- a/src/corelib/text/qlocale.h
#+++ b/src/corelib/text/qlocale.h
#@@ -93,7 +93,9 @@ public:
#         Basque = 14,
#         Bengali = 15,
#         Dzongkha = 16,
#-        Bihari = 17,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        Bihari Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 17,
#+#endif
#         Bislama = 18,
#         Breton = 19,
#         Bulgarian = 20,
#@@ -326,7 +328,9 @@ public:
#         Nuer = 247,
#         Sakha = 248,
#         Sangu = 249,
#-        CongoSwahili = 250,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        CongoSwahili Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 250,
#+#endif
#         Tasawaq = 251,
#         Vai = 252,
#         Walser = 253,
#@@ -346,47 +350,69 @@ public:
#         Bamun = 267,
#         BatakToba = 268,
#         Buginese = 269,
#-        Buhid = 270,
#-        Carian = 271,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        Buhid Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 270,
#+        Carian Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 271,
#+#endif
#         Chakma = 272,
#-        ClassicalMandaic = 273,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        ClassicalMandaic Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 273,
#+#endif
#         Coptic = 274,
#         Dogri = 275,
#-        EasternCham = 276,
#-        EasternKayah = 277,
#-        Etruscan = 278,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        EasternCham Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 276,
#+        EasternKayah Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 277,
#+        Etruscan Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 278,
#+#endif
#         Gothic = 279,
#-        Hanunoo = 280,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        Hanunoo Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 280,
#+#endif
#         Ingush = 281,
#-        LargeFloweryMiao = 282,
#-        Lepcha = 283,
#-        Limbu = 284,
#-        Lisu = 285,
#-        Lu = 286,
#-        Lycian = 287,
#-        Lydian = 288,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        LargeFloweryMiao Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 282,
#+        Lepcha Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 283,
#+        Limbu Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 284,
#+        Lisu Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 285,
#+        Lu Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 286,
#+        Lycian Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 287,
#+        Lydian Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 288,
#+#endif
#         Mandingo = 289,
#         Manipuri = 290,
#-        Meroitic = 291,
#-        NorthernThai = 292,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        Meroitic Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 291,
#+        NorthernThai Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 292,
#+#endif
#         OldIrish = 293,
#         OldNorse = 294,
#         OldPersian = 295,
#-        OldTurkish = 296,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        OldTurkish Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 296,
#+#endif
#         Pahlavi = 297,
#-        Parthian = 298,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        Parthian Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 298,
#+#endif
#         Phoenician = 299,
#-        PrakritLanguage = 300,
#-        Rejang = 301,
#-        Sabaean = 302,
#-        Samaritan = 303,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        PrakritLanguage Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 300,
#+        Rejang Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 301,
#+        Sabaean Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 302,
#+        Samaritan Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 303,
#+#endif
#         Santali = 304,
#         Saurashtra = 305,
#-        Sora = 306,
#-        Sylheti = 307,
#-        Tagbanwa = 308,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        Sora Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 306,
#+        Sylheti Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 307,
#+        Tagbanwa Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 308,
#+#endif
#         TaiDam = 309,
#-        TaiNua = 310,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        TaiNua Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 310,
#+#endif
#         Ugaritic = 311,
#         Akoose = 312,
#         Lakota = 313,
#@@ -405,37 +431,57 @@ public:
#         InariSami = 326,
#         SkoltSami = 327,
#         Warlpiri = 328,
#-        ManichaeanMiddlePersian = 329,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        ManichaeanMiddlePersian Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 329,
#+#endif
#         Mende = 330,
#-        AncientNorthArabian = 331,
#-        LinearA = 332,
#-        HmongNjua = 333,
#-        Ho = 334,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        AncientNorthArabian Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 331,
#+        LinearA Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 332,
#+        HmongNjua Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 333,
#+        Ho Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 334,
#+#endif
#         Lezghian = 335,
#-        Bassa = 336,
#-        Mono = 337,
#-        TedimChin = 338,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        Bassa Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 336,
#+        Mono Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 337,
#+        TedimChin Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 338,
#+#endif
#         Maithili = 339,
#-        Ahom = 340,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        Ahom Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 340,
#+#endif
#         AmericanSignLanguage = 341,
#-        ArdhamagadhiPrakrit = 342,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        ArdhamagadhiPrakrit Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 342,
#+#endif
#         Bhojpuri = 343,
#-        HieroglyphicLuwian = 344,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        HieroglyphicLuwian Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 344,
#+#endif
#         LiteraryChinese = 345,
#         Mazanderani = 346,
#-        Mru = 347,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        Mru Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 347,
#+#endif
#         Newari = 348,
#         NorthernLuri = 349,
#         Palauan = 350,
#         Papiamento = 351,
#-        Saraiki = 352,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        Saraiki Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 352,
#+#endif
#         TokelauLanguage = 353,
#         TokPisin = 354,
#         TuvaluLanguage = 355,
#-        UncodedLanguages = 356,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        UncodedLanguages Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 356,
#+#endif
#         Cantonese = 357,
#         Osage = 358,
#-        Tangut = 359,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        Tangut Q_DECL_ENUMERATOR_DEPRECATED_X("No locale data for this language") = 359,
#+#endif
#         Ido = 360,
#         Lojban = 361,
#         Sicilian = 362,
#diff --git a/src/corelib/text/qlocale.qdoc b/src/corelib/text/qlocale.qdoc
#index b79f178a5e..56f65766dd 100644
#--- a/src/corelib/text/qlocale.qdoc
#+++ b/src/corelib/text/qlocale.qdoc
#@@ -111,7 +111,7 @@
#     \value Afar
#     \value Afrikaans
#     \value Aghem
#-    \value Ahom Since Qt 5.7
#+    \value Ahom Obsolete, no locale data available
#     \value Akan
#     \value Akkadian Since Qt 5.1
#     \value Akoose Since Qt 5.3
#@@ -120,11 +120,11 @@
#     \value Amharic
#     \value AncientEgyptian Since Qt 5.1
#     \value AncientGreek Since Qt 5.1
#-    \value AncientNorthArabian Since Qt 5.5
#+    \value AncientNorthArabian Obsolete, no locale data available
#     \value Arabic
#     \value Aragonese Since Qt 5.1
#     \value Aramaic Since Qt 5.1
#-    \value ArdhamagadhiPrakrit Since Qt 5.7
#+    \value ArdhamagadhiPrakrit Obsolete, no locale data available
#     \value Armenian
#     \value Assamese
#     \value Asturian
#@@ -141,7 +141,7 @@
#     \value Basaa
#     \value Bashkir
#     \value Basque
#-    \value Bassa Since Qt 5.5
#+    \value Bassa Obsolete, no locale data available
#     \value BatakToba Since Qt 5.1
#     \value Belarusian
#     \value Bemba
#@@ -149,20 +149,20 @@
#     \value Bengali
#     \value Bhojpuri Since Qt 5.7
#     \value Bhutani Obsolete, please use Dzongkha
#-    \value Bihari
#+    \value Bihari Obsolete, no locale data available
#     \value Bislama
#     \value Blin
#     \value Bodo
#     \value Bosnian
#     \value Breton
#     \value Buginese Since Qt 5.1
#-    \value Buhid Since Qt 5.1
#+    \value Buhid Obsolete, no locale data available
#     \value Bulgarian
#     \value Burmese
#     \value Byelorussian Obsolete, please use Belarusian
#     \value Cambodian Obsolete, please use Khmer
#     \value Cantonese Since Qt 5.7
#-    \value Carian Since Qt 5.1
#+    \value Carian Obsolete, no locale data available
#     \value Catalan
#     \value Cebuano Since Qt 5.14
#     \value CentralKurdish Since Qt 5.5
#@@ -177,9 +177,9 @@
#     \value Chinese (Mandarin)
#     \value Church
#     \value Chuvash
#-    \value ClassicalMandaic Since Qt 5.1
#+    \value ClassicalMandaic Obsolete, no locale data available
#     \value Colognian
#-    \value CongoSwahili
#+    \value CongoSwahili Obsolete, no locale data available
#     \value Coptic Since Qt 5.1
#     \value Cornish
#     \value Corsican
#@@ -192,14 +192,14 @@
#     \value Duala
#     \value Dutch
#     \value Dzongkha
#-    \value EasternCham Since Qt 5.1
#-    \value EasternKayah Since Qt 5.1
#+    \value EasternCham Obsolete, no locale data available
#+    \value EasternKayah Obsolete, no locale data available
#     \value Embu
#     \value English
#     \value Erzya Since Qt 5.14
#     \value Esperanto
#     \value Estonian
#-    \value Etruscan Since Qt 5.1
#+    \value Etruscan Obsolete, no locale data available
#     \value Ewe
#     \value Ewondo
#     \value Faroese
#@@ -224,16 +224,16 @@
#     \value Gujarati
#     \value Gusii
#     \value Haitian
#-    \value Hanunoo Since Qt 5.1
#+    \value Hanunoo Obsolete, no locale data available
#     \value Hausa
#     \value Hawaiian
#     \value Hebrew
#     \value Herero
#-    \value HieroglyphicLuwian Since Qt 5.7
#+    \value HieroglyphicLuwian Obsolete, no locale data available
#     \value Hindi
#     \value HiriMotu
#-    \value HmongNjua Since Qt 5.5
#-    \value Ho Since Qt 5.5
#+    \value HmongNjua Obsolete, no locale data available
#+    \value Ho Obsolete, no locale data available
#     \value Hungarian
#     \value Icelandic
#     \value Ido Since Qt 5.12
#@@ -281,16 +281,16 @@
#     \value Lakota Since Qt 5.3
#     \value Langi
#     \value Lao
#-    \value LargeFloweryMiao Since Qt 5.1
#+    \value LargeFloweryMiao Obsolete, no locale data available
#     \value Latin
#     \value Latvian
#-    \value Lepcha Since Qt 5.1
#+    \value Lepcha Obsolete, no locale data available
#     \value Lezghian Since Qt 5.5
#     \value Limburgish
#-    \value Limbu Since Qt 5.1
#-    \value LinearA Since Qt 5.5
#+    \value Limbu Obsolete, no locale data available
#+    \value LinearA Obsolete, no locale data available
#     \value Lingala
#-    \value Lisu Since Qt 5.1
#+    \value Lisu Obsolete, no locale data available
#     \value LiteraryChinese Since Qt 5.7
#     \value Lithuanian
#     \value Lojban Since Qt 5.12
#@@ -299,11 +299,11 @@
#     \value LubaKatanga
#     \value LuleSami Since Qt 5.5
#     \value Luo
#-    \value Lu Since Qt 5.1
#+    \value Lu Obsolete, no locale data available
#     \value Luxembourgish
#     \value Luyia
#-    \value Lycian Since Qt 5.1
#-    \value Lydian Since Qt 5.1
#+    \value Lycian Obsolete, no locale data available
#+    \value Lydian Obsolete, no locale data available
#     \value Macedonian
#     \value Machame
#     \value Maithili Since Qt 5.5
#@@ -314,7 +314,7 @@
#     \value Malayalam
#     \value Maltese
#     \value Mandingo Since Qt 5.1
#-    \value ManichaeanMiddlePersian Since Qt 5.5
#+    \value ManichaeanMiddlePersian Obsolete, no locale data available
#     \value Manipuri Since Qt 5.1
#     \value Manx
#     \value Maori
#@@ -324,15 +324,15 @@
#     \value Masai
#     \value Mazanderani Since Qt 5.7
#     \value Mende Since Qt 5.5
#-    \value Meroitic Since Qt 5.1
#+    \value Meroitic Obsolete, no locale data available
#     \value Meru
#     \value Meta
#     \value Mohawk Since Qt 5.5
#     \value Moldavian Obsolete, please use Romanian
#     \value Mongolian
#-    \value Mono Since Qt 5.5
#+    \value Mono Obsolete, no locale data available
#     \value Morisyen
#-    \value Mru Since Qt 5.7
#+    \value Mru Obsolete, no locale data available
#     \value Mundang
#     \value Muscogee Since Qt 5.14
#     \value Nama
#@@ -347,7 +347,7 @@
#     \value NorthernLuri Since Qt 5.7
#     \value NorthernSami
#     \value NorthernSotho
#-    \value NorthernThai Since Qt 5.1
#+    \value NorthernThai Obsolete, no locale data available
#     \value NorthNdebele
#     \value NorwegianBokmal same as Norwegian
#     \value NorwegianNynorsk
#@@ -360,7 +360,7 @@
#     \value OldIrish Since Qt 5.1
#     \value OldNorse Since Qt 5.1
#     \value OldPersian Since Qt 5.1
#-    \value OldTurkish Since Qt 5.1
#+    \value OldTurkish Obsolete, no locale data available
#     \value Oriya
#     \value Oromo
#     \value Osage Since Qt 5.7
#@@ -369,17 +369,17 @@
#     \value Palauan Since Qt 5.7
#     \value Pali
#     \value Papiamento Since Qt 5.7
#-    \value Parthian Since Qt 5.1
#+    \value Parthian Obsolete, no locale data available
#     \value Pashto
#     \value Persian
#     \value Phoenician Since Qt 5.1
#     \value Polish
#     \value Portuguese
#-    \value PrakritLanguage Since Qt 5.1
#+    \value PrakritLanguage Obsolete, no locale data available
#     \value Prussian Since Qt 5.5
#     \value Punjabi
#     \value Quechua
#-    \value Rejang Since Qt 5.1
#+    \value Rejang Obsolete, no locale data available
#     \value RhaetoRomance Obsolete, please use Romansh
#     \value Romanian
#     \value Romansh
#@@ -387,17 +387,17 @@
#     \value Rundi
#     \value Russian
#     \value Rwa
#-    \value Sabaean Since Qt 5.1
#+    \value Sabaean Obsolete, no locale data available
#     \value Saho
#     \value Sakha
#-    \value Samaritan Since Qt 5.1
#+    \value Samaritan Obsolete, no locale data available
#     \value Samburu
#     \value Samoan
#     \value Sango
#     \value Sangu
#     \value Sanskrit
#     \value Santali Since Qt 5.1
#-    \value Saraiki Since Qt 5.7
#+    \value Saraiki Obsolete, no locale data available
#     \value Sardinian
#     \value Saurashtra Since Qt 5.1
#     \value Sena
#@@ -416,7 +416,7 @@
#     \value Slovenian
#     \value Soga
#     \value Somali
#-    \value Sora Since Qt 5.1
#+    \value Sora Obsolete, no locale data available
#     \value SouthernKurdish Since Qt 5.12
#     \value SouthernSami Since Qt 5.5
#     \value SouthernSotho
#@@ -428,22 +428,22 @@
#     \value Swati
#     \value Swedish
#     \value SwissGerman
#-    \value Sylheti Since Qt 5.1
#+    \value Sylheti Obsolete, no locale data available
#     \value Syriac
#     \value Tachelhit
#     \value Tagalog Obsolete, please use Filipino
#-    \value Tagbanwa Since Qt 5.1
#+    \value Tagbanwa Obsolete, no locale data available
#     \value Tahitian
#     \value TaiDam Since Qt 5.1
#-    \value TaiNua Since Qt 5.1
#+    \value TaiNua Obsolete, no locale data available
#     \value Taita
#     \value Tajik
#     \value Tamil
#-    \value Tangut Since Qt 5.7
#+    \value Tangut Obsolete, no locale data available
#     \value Taroko
#     \value Tasawaq
#     \value Tatar
#-    \value TedimChin Since Qt 5.5
#+    \value TedimChin Obsolete, no locale data available
#     \value Telugu
#     \value Teso
#     \value Thai
#@@ -464,7 +464,7 @@
#     \value Uighur
#     \value Uigur Obsolete, please use Uighur
#     \value Ukrainian
#-    \value UncodedLanguages Since Qt 5.7
#+    \value UncodedLanguages Obsolete, no locale data available
#     \value UpperSorbian Since Qt 5.5
#     \value Urdu
#     \value Uzbek
#diff --git a/tests/auto/corelib/text/qlocale/tst_qlocale.cpp b/tests/auto/corelib/text/qlocale/tst_qlocale.cpp
#index 62654adc6a..1afbc169a7 100644
#--- a/tests/auto/corelib/text/qlocale/tst_qlocale.cpp
#+++ b/tests/auto/corelib/text/qlocale/tst_qlocale.cpp
#@@ -2779,13 +2779,23 @@ void tst_QLocale::textDirection_data()
#         bool rightToLeft = false;
#         switch (language) {
#         // based on likelySubtags for RTL scripts
#-        case QLocale::AncientGreek:
#+#if QT_DEPRECATED_SINCE(5, 15)
#         case QLocale::AncientNorthArabian:
#+        case QLocale::ClassicalMandaic:
#+        case QLocale::Lydian:
#+        case QLocale::ManichaeanMiddlePersian:
#+        case QLocale::Meroitic:
#+        case QLocale::OldTurkish:
#+        case QLocale::Parthian:
#+        case QLocale::PrakritLanguage:
#+        case QLocale::Sabaean:
#+        case QLocale::Samaritan:
#+#endif
#+        case QLocale::AncientGreek:
#         case QLocale::Arabic:
#         case QLocale::Aramaic:
#         case QLocale::Avestan:
#         case QLocale::CentralKurdish:
#-        case QLocale::ClassicalMandaic:
#         case QLocale::Divehi:
# //        case QLocale::Fulah:
# //        case QLocale::Hausa:
#@@ -2793,23 +2803,15 @@ void tst_QLocale::textDirection_data()
# //        case QLocale::Hungarian:
#         case QLocale::Kashmiri:
# //        case QLocale::Kurdish:
#-        case QLocale::Lydian:
#         case QLocale::Mandingo:
#-        case QLocale::ManichaeanMiddlePersian:
#         case QLocale::Mazanderani:
#         case QLocale::Mende:
#-        case QLocale::Meroitic:
#         case QLocale::Nko:
#         case QLocale::NorthernLuri:
#-        case QLocale::OldTurkish:
#         case QLocale::Pahlavi:
#-        case QLocale::Parthian:
#         case QLocale::Pashto:
#         case QLocale::Persian:
#         case QLocale::Phoenician:
#-        case QLocale::PrakritLanguage:
#-        case QLocale::Sabaean:
#-        case QLocale::Samaritan:
#         case QLocale::Sindhi:
#         case QLocale::SouthernKurdish:
#         case QLocale::Syriac:
#-- 
#2.33.0
#
#From 9fbc5f148910dfb3fcca5f242a88f4726a72e484 Mon Sep 17 00:00:00 2001
#From: Edward Welbourne <edward.welbourne@qt.io>
#Date: Tue, 20 Oct 2020 11:41:13 +0200
#Subject: [PATCH 009/262] Deprecate old aliases for two countries and several
# languages
#
#[ChangeLog][QtCore][QLocale] Deprecated several Language and Country
#aliases, ready for removal in Qt 6.0, in favor of their newer names.
#
#Task-number: QTBUG-84669
#Change-Id: Iebaa0a5a77bfa12f7014de53fab4a25b5f1cc92c
#Reviewed-by: Lars Knoll <lars.knoll@qt.io>
#(cherry picked from commit 2c4874be40aa40b698315cac0ad768e5c650a740)
#Reviewed-by: Edward Welbourne <edward.welbourne@qt.io>
#---
# src/corelib/text/qlocale.cpp                  | 24 +++++++------------
# src/corelib/text/qlocale.h                    | 20 ++++++++++------
# src/corelib/text/qlocale.qdoc                 |  4 ++--
# .../corelib/text/qcollator/tst_qcollator.cpp  |  4 ++--
# .../auto/corelib/text/qlocale/tst_qlocale.cpp | 14 +++++------
# .../qdoublespinbox/tst_qdoublespinbox.cpp     | 14 +++++------
# .../widgets/widgets/qspinbox/tst_qspinbox.cpp |  2 +-
# 7 files changed, 40 insertions(+), 42 deletions(-)
#
#diff --git a/src/corelib/text/qlocale.cpp b/src/corelib/text/qlocale.cpp
#index 4617168781..bfd7b15e6b 100644
#--- a/src/corelib/text/qlocale.cpp
#+++ b/src/corelib/text/qlocale.cpp
#@@ -115,22 +115,14 @@ QLocale::Language QLocalePrivate::codeToLanguage(QStringView code) noexcept
# 
#     if (uc3 == 0) {
#         // legacy codes
#-        if (uc1 == 'n' && uc2 == 'o') { // no -> nb
#-            Q_STATIC_ASSERT(QLocale::Norwegian == QLocale::NorwegianBokmal);
#-            return QLocale::Norwegian;
#-        }
#-        if (uc1 == 't' && uc2 == 'l') { // tl -> fil
#-            Q_STATIC_ASSERT(QLocale::Tagalog == QLocale::Filipino);
#-            return QLocale::Tagalog;
#-        }
#-        if (uc1 == 's' && uc2 == 'h') { // sh -> sr[_Latn]
#-            Q_STATIC_ASSERT(QLocale::SerboCroatian == QLocale::Serbian);
#-            return QLocale::SerboCroatian;
#-        }
#-        if (uc1 == 'm' && uc2 == 'o') { // mo -> ro
#-            Q_STATIC_ASSERT(QLocale::Moldavian == QLocale::Romanian);
#-            return QLocale::Moldavian;
#-        }
#+        if (uc1 == 'n' && uc2 == 'o') // no -> nb
#+            return QLocale::NorwegianBokmal;
#+        if (uc1 == 't' && uc2 == 'l') // tl -> fil
#+            return QLocale::Filipino;
#+        if (uc1 == 's' && uc2 == 'h') // sh -> sr[_Latn]
#+            return QLocale::Serbian;
#+        if (uc1 == 'm' && uc2 == 'o') // mo -> ro
#+            return QLocale::Romanian;
#         // Android uses the following deprecated codes
#         if (uc1 == 'i' && uc2 == 'w') // iw -> he
#             return QLocale::Hebrew;
#diff --git a/src/corelib/text/qlocale.h b/src/corelib/text/qlocale.h
#index 64dd32cabc..036f064419 100644
#--- a/src/corelib/text/qlocale.h
#+++ b/src/corelib/text/qlocale.h
#@@ -501,12 +501,16 @@ public:
#         Chewa = Nyanja,
#         Frisian = WesternFrisian,
#         Kurundi = Rundi,
#-        Moldavian = Romanian,
#-        Norwegian = NorwegianBokmal,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        Moldavian Q_DECL_ENUMERATOR_DEPRECATED_X("Obsolete name, use Romanian") = Romanian,
#+        Norwegian Q_DECL_ENUMERATOR_DEPRECATED_X("Obsolete name, use NorwegianBokmal") = NorwegianBokmal,
#+#endif
#         RhaetoRomance = Romansh,
#-        SerboCroatian = Serbian,
#-        Tagalog = Filipino,
#-        Twi = Akan,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        SerboCroatian Q_DECL_ENUMERATOR_DEPRECATED_X("Obsolete name, use Serbian") = Serbian,
#+        Tagalog Q_DECL_ENUMERATOR_DEPRECATED_X("Obsolete name, use Filipino") = Filipino,
#+        Twi Q_DECL_ENUMERATOR_DEPRECATED_X("Obsolete name, use Akan") = Akan,
#+#endif
#         Uigur = Uighur,
# 
#         LastLanguage = NigerianPidgin
#@@ -933,8 +937,10 @@ public:
#         RepublicOfKorea = SouthKorea,
#         RussianFederation = Russia,
#         SyrianArabRepublic = Syria,
#-        Tokelau = TokelauCountry,
#-        Tuvalu = TuvaluCountry,
#+#if QT_DEPRECATED_SINCE(5, 15)
#+        Tokelau Q_DECL_ENUMERATOR_DEPRECATED_X("Obsolete name, use TokelauCountry") = TokelauCountry,
#+        Tuvalu Q_DECL_ENUMERATOR_DEPRECATED_X("Obsolete name, use TuvaluCountry") = TuvaluCountry,
#+#endif
# 
#         LastCountry = Europe
#     };
#diff --git a/src/corelib/text/qlocale.qdoc b/src/corelib/text/qlocale.qdoc
#index 56f65766dd..f4b9f5b67d 100644
#--- a/src/corelib/text/qlocale.qdoc
#+++ b/src/corelib/text/qlocale.qdoc
#@@ -349,9 +349,9 @@
#     \value NorthernSotho
#     \value NorthernThai Obsolete, no locale data available
#     \value NorthNdebele
#-    \value NorwegianBokmal same as Norwegian
#+    \value NorwegianBokmal
#     \value NorwegianNynorsk
#-    \value Norwegian same as NorwegianBokmal
#+    \value Norwegian Obsolete, please use NorwegianBokmal
#     \value Nuer
#     \value Nyanja
#     \value Nyankole
#diff --git a/tests/auto/corelib/text/qcollator/tst_qcollator.cpp b/tests/auto/corelib/text/qcollator/tst_qcollator.cpp
#index 6806aa09b5..ab1e2638cd 100644
#--- a/tests/auto/corelib/text/qcollator/tst_qcollator.cpp
#+++ b/tests/auto/corelib/text/qcollator/tst_qcollator.cpp
#@@ -231,12 +231,12 @@ void tst_QCollator::state()
#     c.setLocale(QLocale::French);
#     c.setNumericMode(true);
#     c.setIgnorePunctuation(true);
#-    c.setLocale(QLocale::Norwegian);
#+    c.setLocale(QLocale::NorwegianBokmal);
# 
#     QCOMPARE(c.caseSensitivity(), Qt::CaseInsensitive);
#     QCOMPARE(c.numericMode(), true);
#     QCOMPARE(c.ignorePunctuation(), true);
#-    QCOMPARE(c.locale(), QLocale(QLocale::Norwegian));
#+    QCOMPARE(c.locale(), QLocale(QLocale::NorwegianBokmal));
# 
# }
# 
#diff --git a/tests/auto/corelib/text/qlocale/tst_qlocale.cpp b/tests/auto/corelib/text/qlocale/tst_qlocale.cpp
#index 1afbc169a7..c409494786 100644
#--- a/tests/auto/corelib/text/qlocale/tst_qlocale.cpp
#+++ b/tests/auto/corelib/text/qlocale/tst_qlocale.cpp
#@@ -457,12 +457,11 @@ void tst_QLocale::defaulted_ctor()
#     TEST_CTOR("eo", Esperanto, World)
#     TEST_CTOR("yi", Yiddish, World)
# 
#-    QVERIFY(QLocale::Norwegian == QLocale::NorwegianBokmal);
#-    TEST_CTOR("no", Norwegian, Norway)
#-    TEST_CTOR("nb", Norwegian, Norway)
#+    TEST_CTOR("no", NorwegianBokmal, Norway)
#+    TEST_CTOR("nb", NorwegianBokmal, Norway)
#     TEST_CTOR("nn", NorwegianNynorsk, Norway)
#-    TEST_CTOR("no_NO", Norwegian, Norway)
#-    TEST_CTOR("nb_NO", Norwegian, Norway)
#+    TEST_CTOR("no_NO", NorwegianBokmal, Norway)
#+    TEST_CTOR("nb_NO", NorwegianBokmal, Norway)
#     TEST_CTOR("nn_NO", NorwegianNynorsk, Norway)
#     TEST_CTOR("es_ES", Spanish, Spain)
#     TEST_CTOR("es_419", Spanish, LatinAmerica)
#@@ -648,9 +647,9 @@ void tst_QLocale::emptyCtor()
# 
# void tst_QLocale::legacyNames()
# {
#-    QVERIFY(QLocale::Norwegian == QLocale::NorwegianBokmal);
#     QLocale::setDefault(QLocale(QLocale::C));
# 
#+#if QT_DEPRECATED_SINCE(5, 15)
# #define TEST_CTOR(req_lang, req_country, exp_lang, exp_country) \
#     { \
#         QLocale l(QLocale::req_lang, QLocale::req_country); \
#@@ -664,6 +663,7 @@ void tst_QLocale::legacyNames()
#     TEST_CTOR(Tagalog, AnyCountry, Filipino, Philippines)
# 
# #undef TEST_CTOR
#+#endif
# 
# #define TEST_CTOR(req_lc, exp_lang, exp_country) \
#     { \
#@@ -677,7 +677,7 @@ void tst_QLocale::legacyNames()
#     }
# 
#     TEST_CTOR("mo_MD", Romanian, Moldova)
#-    TEST_CTOR("no", Norwegian, Norway)
#+    TEST_CTOR("no", NorwegianBokmal, Norway)
#     TEST_CTOR("sh_ME", Serbian, Montenegro)
#     TEST_CTOR("tl", Filipino, Philippines)
#     TEST_CTOR("iw", Hebrew, Israel)
#diff --git a/tests/auto/widgets/widgets/qdoublespinbox/tst_qdoublespinbox.cpp b/tests/auto/widgets/widgets/qdoublespinbox/tst_qdoublespinbox.cpp
#index c293a4bdd2..986a830b8b 100644
#--- a/tests/auto/widgets/widgets/qdoublespinbox/tst_qdoublespinbox.cpp
#+++ b/tests/auto/widgets/widgets/qdoublespinbox/tst_qdoublespinbox.cpp
#@@ -777,17 +777,17 @@ void tst_QDoubleSpinBox::valueFromTextAndValidate_data()
#     QTest::newRow("data1") << QString() << Intermediate << 0.0 << 100.0 << (int)QLocale::C << QString();
#     QTest::newRow("data2") << QString("asd") << Invalid << 0.0 << 100.0 << (int)QLocale::C << QString();
#     QTest::newRow("data3") << QString("2.2") << Acceptable << 0.0 << 100.0 << (int)QLocale::C << QString();
#-    QTest::newRow("data4") << QString(" ") << Intermediate << 0.0 << 100.0 << (int)QLocale::Norwegian << QString();
#+    QTest::newRow("data4") << QString(" ") << Intermediate << 0.0 << 100.0 << (int)QLocale::NorwegianBokmal << QString();
#     QTest::newRow("data5") << QString(" ") << Intermediate << 0.0 << 100.0 << (int)QLocale::C << QString();
#-    QTest::newRow("data6") << QString(",") << Intermediate << 0.0 << 100.0 << (int)QLocale::Norwegian << QString();
#+    QTest::newRow("data6") << QString(",") << Intermediate << 0.0 << 100.0 << (int)QLocale::NorwegianBokmal << QString();
#     QTest::newRow("data7") << QString(",") << Invalid << 0.0 << 100.0 << (int)QLocale::C << QString();
#-    QTest::newRow("data8") << QString("1 ") << Acceptable << 0.0 << 1000.0 << (int)QLocale::Norwegian << QString("1");
#+    QTest::newRow("data8") << QString("1 ") << Acceptable << 0.0 << 1000.0 << (int)QLocale::NorwegianBokmal << QString("1");
#     QTest::newRow("data9") << QString("1 ") << Acceptable << 0.0 << 100.0 << (int)QLocale::C << QString("1");
#-    QTest::newRow("data10") << QString(" 1") << Acceptable << 0.0 << 100.0 << (int)QLocale::Norwegian << QString("1");
#+    QTest::newRow("data10") << QString(" 1") << Acceptable << 0.0 << 100.0 << (int)QLocale::NorwegianBokmal << QString("1");
#     QTest::newRow("data11") << QString(" 1") << Acceptable << 0.0 << 100.0 << (int)QLocale::C << QString("1");
#-    QTest::newRow("data12") << QString("1,") << Acceptable << 0.0 << 100.0 << (int)QLocale::Norwegian << QString();
#+    QTest::newRow("data12") << QString("1,") << Acceptable << 0.0 << 100.0 << (int)QLocale::NorwegianBokmal << QString();
#     QTest::newRow("data13") << QString("1,") << Acceptable << 0.0 << 1000.0 << (int)QLocale::C << QString();
#-    QTest::newRow("data14") << QString("1, ") << Acceptable << 0.0 << 100.0 << (int)QLocale::Norwegian << QString("1,");
#+    QTest::newRow("data14") << QString("1, ") << Acceptable << 0.0 << 100.0 << (int)QLocale::NorwegianBokmal << QString("1,");
#     QTest::newRow("data15") << QString("1, ") << Invalid << 0.0 << 100.0 << (int)QLocale::C << QString();
#     QTest::newRow("data16") << QString("2") << Intermediate << 100.0 << 102.0 << (int)QLocale::C << QString();
#     QTest::newRow("data17") << QString("22.0") << Intermediate << 100.0 << 102.0 << (int)QLocale::C << QString();
#@@ -826,7 +826,7 @@ void tst_QDoubleSpinBox::valueFromTextAndValidate_data()
#     QTest::newRow("data50") << QString("2.2") << Acceptable << 0.0 << 1000.0 << (int)QLocale::C << QString();
#     QTest::newRow("data51") << QString("2.2,00") << Invalid << 0.0 << 1000.0 << (int)QLocale::C << QString();
#     QTest::newRow("data52") << QString("2..2,00") << Invalid << 0.0 << 1000.0 << (int)QLocale::German << QString();
#-    QTest::newRow("data53") << QString("2.2") << Invalid << 0.0 << 1000.0 << (int)QLocale::Norwegian << QString();
#+    QTest::newRow("data53") << QString("2.2") << Invalid << 0.0 << 1000.0 << (int)QLocale::NorwegianBokmal << QString();
#     QTest::newRow("data54") << QString("  2.2") << Acceptable << 0.0 << 1000.0 << (int)QLocale::C << QString();
#     QTest::newRow("data55") << QString("2.2  ") << Acceptable << 0.0 << 1000.0 << (int)QLocale::C << QString("2.2");
#     QTest::newRow("data56") << QString("  2.2  ") << Acceptable << 0.0 << 1000.0 << (int)QLocale::C << QString("2.2");
#diff --git a/tests/auto/widgets/widgets/qspinbox/tst_qspinbox.cpp b/tests/auto/widgets/widgets/qspinbox/tst_qspinbox.cpp
#index f8022559b2..0516bf5a16 100644
#--- a/tests/auto/widgets/widgets/qspinbox/tst_qspinbox.cpp
#+++ b/tests/auto/widgets/widgets/qspinbox/tst_qspinbox.cpp
#@@ -877,7 +877,7 @@ void tst_QSpinBox::locale_data()
#     QTest::addColumn<QString>("text");
#     QTest::addColumn<int>("valFromText");
# 
#-    QTest::newRow("data0") << QLocale(QLocale::Norwegian, QLocale::Norway) << 1234 << QString("1234") << QString("2345") << 2345;
#+    QTest::newRow("data0") << QLocale(QLocale::NorwegianBokmal, QLocale::Norway) << 1234 << QString("1234") << QString("2345") << 2345;
#     QTest::newRow("data1") << QLocale(QLocale::German, QLocale::Germany) << 1234 << QString("1234") << QString("2345") << 2345;
# }
# 
#-- 
#2.33.0
#
